<!DOCTYPE html>
<html lang="pl-PL">
<%- include('../partials/_head.ejs') %>
<body>
  <style>
    #submitButton {
        padding: 10px;
        width: 150px;
        background-color: transparent;
        color: #0984e3;
        border-radius: 25px;
        border: 1px solid #0984e3;
        transition: 0.2s ease-in-out;
    }
    #submitButton:hover {
        background-color: #0984e3;
        color: azure;
    }
    main {
        padding-bottom: 100px; /* Dodaj dolny padding do main aby zapewnić widoczność przycisku */
    }
  </style>
<%- include('../partials/_header.ejs') %>
<main role="main" class="container mt-4">
  <h2>Utwórz nowe zadanie</h2>
  <div id="alert-container" class="alert alert-danger d-none" role="alert"></div>
  <form id="taskForm">
    <div class="mb-3">
      <label for="title" class="form-label">Tytuł</label>
      <input type="text" class="form-control" id="title" name="title" required>
    </div>
    <div class="mb-3">
      <label for="taskType" class="form-label">Typ zadania</label>
      <select class="form-select" id="taskType" name="taskType" required>
        <option value="AEB (jednorodzinny)">AEB (jednorodzinny)</option>
        <option value="AEB (pozostałe)">AEB (pozostałe)</option>
        <option value="AEE pre">AEE pre</option>
        <option value="AEE post">AEE post</option>
        <option value="AEP">AEP</option>
        <option value="ISO 50001 - Etap 0">ISO 50001 - Etap 0</option>
        <option value="ISO 50001 - Etap 1">ISO 50001 - Etap 1</option>
        <option value="ISO 50001 - Etap 2">ISO 50001 - Etap 2</option>
        <option value="ISO 50001 - Etap 3">ISO 50001 - Etap 3</option>
        <option value="ISO 50001 - Etap 4">ISO 50001 - Etap 4</option>
        <option value="ISO 50001 - Etap 5">ISO 50001 - Etap 5</option>
        <option value="ISO 50001 - Etap 6">ISO 50001 - Etap 6</option>
        <option value="ISO 50001 - Etap 7">ISO 50001 - Etap 7</option>
        <option value="ISO 50001 - Etap 8">ISO 50001 - Etap 8</option>
        <option value="ISO 50001 - Etap 9">ISO 50001 - Etap 9</option>
        <option value="ŚChE (opracowanie)">ŚChE (opracowanie)</option>
        <option value="ŚChE (jednorodzinny)">ŚChE (jednorodzinny)</option>
        <option value="ŚChE (wielorodzinny)">ŚChE (wielorodzinny)</option>
        <option value="Art. 45a">Art. 45a</option>
        <option value="GOZ">GOZ</option>
        <option value="Niezależna ekspertyza RM">Niezależna ekspertyza RM</option>
        <option value="Niezależna ekspertyza RM OKM">Niezależna ekspertyza RM OKM</option>
        <option value="CP wniosek">CP wniosek</option>
        <option value="CP płatność">CP płatność</option>
        <option value="Dokument audytu 3.1">Dokument audytu 3.1</option>
        <option value="Ślad węglowy">Ślad węglowy</option>
        <option value="Fotowoltaika">Fotowoltaika</option>
        <option value="Pompa ciepła">Pompa ciepła</option>
        <option value="Projekt od 15 tyś. zł">Projekt od 15 tyś. zł</option>
        <option value="Projekt do 15 tyś. zł">Projekt do 15 tyś. zł</option>
        <option value="Szkolenie">Szkolenie</option>
        <option value="Pomiary od 15 tyś.">Pomiary od 15 tyś.</option>
        <option value="Pomiary poniżej 15 tyś.">Pomiary poniżej 15 tyś.</option>
        <option value="Opracowanie dokumentacji od 15 tyś.">Opracowanie dokumentacji od 15 tyś.</option>
        <option value="Opracowanie dokumentacji poniżej 15 tyś.">Opracowanie dokumentacji poniżej 15 tyś.</option>
        <option value="Utrzymanie SZE">Utrzymanie SZE</option>
        <option value="Ekspertyza OZE">Ekspertyza OZE</option>
      </select>
    </div>
    <div class="mb-3">
      <label for="description" class="form-label">Opis</label>
      <textarea class="form-control" id="description" name="description" rows="1" required></textarea>
    </div>
    <div class="mb-3">
      <label for="priority" class="form-label">Priorytet</label>
      <select class="form-select" id="priority" name="priority" required>
        <option value="Low">Niski</option>
        <option value="Medium">Średni</option>
        <option value="High">Wysoki</option>
      </select>
    </div>
    <div class="mb-3">
      <label for="tags" class="form-label">Tagi (oddzielone przecinkiem)</label>
      <input type="text" class="form-control" id="tags" name="tags">
    </div>
    <div class="mb-3">
      <label for="duration" class="form-label">Czas trwania (w godzinach)</label>
      <input type="number" class="form-control" id="duration" name="duration" required>
    </div>
    <div class="mb-3">
      <label for="projectHandover" class="form-label">Data zakończenia audytu/projektu/usługi z umowy</label>
      <input type="date" class="form-control" id="projectHandover" name="projectHandover">
    </div>
    <div class="mb-3">
      <label for="notEarlierThan" class="form-label">Data rozpoczęcia realizacji audytu/projektu/usługi</label>
      <input type="date" class="form-control" id="notEarlierThan" name="notEarlierThan">
    </div>
    <% if (userRole === 'Admin' || userRole === 'Manager') { %>
    <div class="mb-3">
      <label for="assignedTo" class="form-label">Przypisz dla</label>
      <select class="form-select" id="assignedTo" name="assignedTo">
        <% users.forEach(function(user) { %>
          <option value="<%= user._id %>"><%= user.username %></option>
        <% }); %>
      </select>
    </div>
    <% } else { %>
      <input type="hidden" name="assignedTo" value="<%= userId %>">
    <% } %>
    <button type="submit" class="btn btn-primary" id="submitButton">Utwórz zadanie</button>
  </form>
</main>

<script>
  const taskTypeElement = document.getElementById('taskType');
  const durationInput = document.getElementById('duration');

  const durations = {
    'AEB (jednorodzinny)': 13,
    'AEB (pozostałe)': 24,
    'AEE pre': 32,
    'AEE post': 22,
    'AEP': 83,
    'ISO 50001 - Etap 0': 13,
    'ISO 50001 - Etap 1': 18,
    'ISO 50001 - Etap 2': 24,
    'ISO 50001 - Etap 3': 122,
    'ISO 50001 - Etap 4': 26,
    'ISO 50001 - Etap 5': 47,
    'ISO 50001 - Etap 6': 37,
    'ISO 50001 - Etap 7': 9,
    'ISO 50001 - Etap 8': 9,
    'ISO 50001 - Etap 9': 13,
    'ŚChE (opracowanie)': 3,
    'ŚChE (jednorodzinny)': 9,
    'ŚChE (wielorodzinny)': 20,
    'Art. 45a': 3,
    'GOZ': 77,
    'Niezależna ekspertyza RM': 83,
    'Niezależna ekspertyza RM OKM': 83,
    'CP wniosek': 9,
    'CP płatność': 9,
    'Dokument audytu 3.1': 13,
    'Ślad węglowy': 62,
    'Fotowoltaika': 20,
    'Pompa ciepła': 24,
    'Projekt od 15 tyś. zł': 83,
    'Projekt do 15 tyś. zł': 43,
    'Szkolenie': 47,
    'Pomiary od 15 tyś.': 83,
    'Pomiary poniżej 15 tyś.': 43,
    'Opracowanie dokumentacji od 15 tyś.': 83,
    'Opracowanie dokumentacji poniżej 15 tyś.': 43,
    'Utrzymanie SZE': 43,
    'Ekspertyza OZE': 26
  };

  function setDurationPlaceholder() {
    const taskType = taskTypeElement.value;
    durationInput.placeholder = `${durations[taskType]} godzin`;
  }

  document.addEventListener('DOMContentLoaded', setDurationPlaceholder);
  taskTypeElement.addEventListener('change', setDurationPlaceholder);

  document.getElementById('taskForm').addEventListener('submit', async function(event) {
    event.preventDefault();

    const form = event.target;
    const formData = new FormData(form);
    const data = Object.fromEntries(formData.entries());

    try {
      const response = await fetch('/tasks', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify(data),
      });

      if (!response.ok) {
        const result = await response.json();
        throw new Error(result.message || 'Adding New Task Failed');
      }

      // If successful, redirect to /tasks page
      window.location.href = '/tasks';
    } catch (error) {
      const alertContainer = document.getElementById('alert-container');
      alertContainer.textContent = error.message;
      alertContainer.classList.remove('d-none');
    }
  });
</script>

<%- include('../partials/_footer.ejs') %>
</body>
</html>
